#include "mywin.h"

/*
  snd_pcm_t *  PcmCTRL::handle;
  snd_pcm_hw_params_t * PcmCTRL::hwparams;
  snd_pcm_sw_params_t * PcmCTRL::swparams;
  snd_output_t * PcmCTRL::output;
  snd_pcm_format_t PcmCTRL::format;
  int PcmCTRL::length;
*/

PcmCTRL::PcmCTRL(){
  //ѿν
  length = 0;
  //ǥեȤ̾
  playDeviceName = uni("plughw:0,0");
  recordDeviceName = uni("plughw:0,0");
}

QString PcmCTRL::setPlayDeviceName(QString newName){
  QString r = playDeviceName;
  playDeviceName = newName;
  return r;
}
QString PcmCTRL::setRecordDeviceName(QString newName){
  QString r = recordDeviceName;
  recordDeviceName = newName;
  return r;
}

QString PcmCTRL::getPlayDeviceName(){
  return playDeviceName;
}
QString PcmCTRL::getRecordDeviceName(){
  return recordDeviceName;
}

int PcmCTRL::openPlay(int ch, int bit, int freq){
  return openDevice(ch, bit, freq, 0);//ꤲ
}
int PcmCTRL::openRecord(int ch, int bit, int freq){
  return openDevice(ch, bit, freq, 1);//ꤲ
}
int PcmCTRL::openDevice(int ch, int bit, int freq, int mode){
  unsigned int rfreq;
  snd_pcm_uframes_t reqBufSize = 1024*1024;//ХåեΥե졼׵
  snd_pcm_uframes_t periodSize = 1;//ǤĤǤǤȤ褤
  int dir = 0;           //
  int bufSize = 0;
  
  //
  hwparams = NULL;
  swparams = NULL;
  output = NULL;
  length = 0;
  snd_pcm_hw_params_malloc(&hwparams); 
  //hwparams = (snd_pcm_hw_params_t *)new char[965536];
  if(hwparams==NULL)
    return -301;
  snd_pcm_sw_params_malloc(&swparams);
  //swparams = (snd_pcm_sw_params_t *) new char[965536];
  if(swparams == NULL)
    return -302;
  if(snd_output_stdio_attach(&output, stdout, 0)<0)
    return -303;
  
  //եޥåȤ
  if(bit == 8)
    format = SND_PCM_FORMAT_U8; //8bit -> unsigned char
  else if(bit==16)
    format = SND_PCM_FORMAT_S16_LE ;//16bit -> signed short
  else
    return -101;
  
  //ϡɥ򳫤
  switch(mode){
  case 0:
    if(snd_pcm_open(&handle, (const char *)playDeviceName,
		    SND_PCM_STREAM_PLAYBACK, SND_PCM_NONBLOCK) < 0)
      return -1;
    break;
  case 1:
    if(snd_pcm_open(&handle, (const char *)recordDeviceName,
		    SND_PCM_STREAM_CAPTURE, SND_PCM_NONBLOCK) < 0)
      return -1;
    break;
  default:
    return -1;
  }
  
  //ϡɥѥ᡼
  if(snd_pcm_hw_params_any(handle, hwparams)<0){
    closePCM();
    return -2;
  }
  if(snd_pcm_hw_params_set_access(handle, hwparams,
				  SND_PCM_ACCESS_RW_INTERLEAVED)<0){
    closePCM();
    return -3;
  }
  if(snd_pcm_hw_params_set_format(handle, hwparams, format)<0){
    closePCM();
    return -4;
  }
  if(snd_pcm_hw_params_set_channels(handle, hwparams, ch)<0){
    closePCM();
    return -5;
  }
  rfreq = freq;
  if(snd_pcm_hw_params_set_rate_near(handle, hwparams, &rfreq, &dir)<0){
    closePCM();
    return -6;
  }
  if(snd_pcm_hw_params_set_buffer_size_near(handle, hwparams, &reqBufSize)<0){
    closePCM();
    return -7;
  }
  if(snd_pcm_hw_params_set_period_size_near(handle, hwparams,
					    &periodSize, &dir) < 0){
    closePCM();
    return -8;
  }
  if(snd_pcm_hw_params(handle, hwparams)<0){
    closePCM();
    return -9;
  }
  //ХåեäѤˤʤȼư: ưȤʻ롣
  if(snd_pcm_sw_params_current(handle, swparams)<0){
    closePCM();
    return -201;
  }
  if(snd_pcm_sw_params_set_start_threshold(handle, swparams, reqBufSize)<0){
    closePCM();
    return -202;
  }
  if(snd_pcm_sw_params(handle, swparams)<0){
    closePCM();
    return -203;
  }
  //prepareƽ񤭹ߤ
  if(snd_pcm_prepare(handle)<0){
    closePCM();
    return -10;
  }
  switch(mode){
  case 0://⡼
    //ǲǽʶ̤ºݤν񤭹߲ǽʥХåե
    if((bufSize = snd_pcm_avail_update(handle))<0){
      closePCM();
      return -11;
    }
    break;
  case 1://Ͽ⡼
    if((bufSize=reqBufSize)<0){
      closePCM();
      return -11;
    }
    break;
  }
  
  //Хåե(ñ̤ϥե졼)֤
  length = (bufSize>=0) ? bufSize : 0;//ѿˤХåեݴ
  return bufSize;
}

int PcmCTRL::prepare(){
  return snd_pcm_prepare(handle);
}
int PcmCTRL::availPCM(){
  return (int)snd_pcm_avail_update(handle);
}
int PcmCTRL::writei(const void *b, unsigned int s){
  return (int)snd_pcm_writei(handle, b, s);
}
int PcmCTRL::readi(void *b, unsigned int s){
  return (int)snd_pcm_readi(handle, b, s);
}
int PcmCTRL::statePCM(){
  return snd_pcm_state(handle);
}
int PcmCTRL::startPCM(){
  return snd_pcm_start(handle);
}
int PcmCTRL::closePCM(){
  //β
  if(hwparams != NULL)
    snd_pcm_hw_params_free(hwparams);
  if(swparams != NULL)
    snd_pcm_sw_params_free(swparams);  
  
  //ǥХĤ
  return snd_pcm_close(handle);
}

int PcmCTRL::dropPCM(){
  return snd_pcm_drop(handle);
}
