#include "mywin.h"

VorbisDialog::VorbisDialog(FileCTRL *fcp, QWidget *parent, const char *name)
  :  QDialog(parent, name){
  //ѿν
  quality = 3.0;
  this->fcp = fcp;
  status = 0;//̤ϻϤޤäƤʤ
  //ν
  setMaximumSize(400,160);
  setMinimumSize(400,160);
  setCaption(uni("ե-ݡ Ogg Vorbis"));
  QLabel *ql;
  ql = new QLabel(uni("Ogg Vorbis: ̤ʼ(<---->)"), this);
  ql->setGeometry(10,2,380,28);
  bar = new QSlider(-10,100,10,30,Qt::Horizontal,this);
  bar->setGeometry(10,30,260,28);
  edit = new QLineEdit(uni("3.0"), this);
  edit->setGeometry(280,30,60,28);
  ok = new QPushButton(uni(""), this);
  ok->setGeometry(10,60,100,28);
  cancel = new QPushButton(uni("󥻥"), this);
  cancel->setGeometry(120,60,100,28);
  prog = new QProgressBar(1000, this);
  prog->setGeometry(5,100,390,28);
  susumi = new QLabel(uni(""), this);
  susumi->setGeometry(5,130,390,28);
  encTimer = new QTimer(this);
  
  //ư
  connect(bar, SIGNAL(valueChanged(int)),
	  this, SLOT(barToEdit()));
  connect(edit, SIGNAL(lostFocus()),
	  this, SLOT(editToBar()));
  connect(ok, SIGNAL(clicked()), this, SLOT(startenc()));
  connect(cancel, SIGNAL(clicked()), this, SLOT(abortenc()));
  connect(encTimer, SIGNAL(timeout()), this, SLOT(runEncode()));
}

int VorbisDialog::setupExec(QString s, int track, int md){
  this->outName = s;
  this->track = track;
  this->mode = md;
  status = 0;
  bar->setEnabled(true);
  edit->setEnabled(true);
  ok->setText(uni(""));
  ok->setEnabled(true);
  cancel->setText(uni("󥻥"));
  cancel->setEnabled(true);
  prog->setProgress(0);
  susumi->setText(uni(""));
  ok->setDefault(true);
  ok->setFocus();
  
  return this->exec();//ɽơդ
}

void VorbisDialog::barToEdit(){
  edit->setText(QString::number(bar->value() * 0.1));
}
void VorbisDialog::editToBar(){
  bar->setValue((int)(edit->text().toFloat() * 10.0));
}
void VorbisDialog::startenc(){
  switch(status){
  case 0:
    //̤ʼ⤦ٳΤ
    quality = edit->text().toFloat();
    if(quality > 10.0) quality = 10.0;
    if(quality < -1.0) quality = -1.0;
    if(!(quality >= -1.0 && quality <= 10.0)) quality = 3.0;
    bar->setValue((int)(quality * 10.0));
    edit->setText(QString::number(quality));
    quality *= 0.1;//ǥ饤֥ͤѴ
    //GUIβ벡ʤѹ
    bar->setDisabled(true);
    edit->setDisabled(true);
    ok->setDisabled(true);
    cancel->setText(uni("")); 
    cancel->setFocus();
    //̤γϽ
    if(initEncode()){
      //顼ξ
      QMessageBox::critical( this, uni("ե-ݡ"),
			     uni("̥롼ν˼Ԥޤ"));
      status = 2;//λ֤ˤ
      this->reject();
    }else{
      //ưϤ(status1ˤʤäƤ)
      runEncode();
    }
    break;
  case 1://˲ϤʤΤǡ⤷ʤ
    break;
  case 2://̽λ
    this->accept();
    break;
  }
}

void VorbisDialog::abortenc(){
  if(status==1){
    //֤1ξߤν򤹤
    status = 3;
    encTimer->stop();
    runEncode();//ߤΤ˸ƤӽФ
  }else{
    //֤0,2ξĤ
    status = 2;//λ֤ꤹ
    this->reject();
  }
}

int VorbisDialog::oe_write_page(ogg_page *page, FILE *fp){
  int written;
  written = fwrite(page->header,1,page->header_len, fp);
  written += fwrite(page->body,1,page->body_len, fp);
  return written;
}

int VorbisDialog::initEncode(){
  long long rcount = 0;
  
  //ϻ¸
  time(&secnow);
  secorg = secnow;
  //ѿν
  ch = mode==0 ? fcp->sampleChannel : 1;//⡼1ʾϥΥ벽Ȥߤʤ
  rate = fcp->sampleFreq;
  eserial = 1;
  retvalue = 0;
  eos = 0;
  fsbuf = NULL;
  samples_read = 0;
  bytes_written = 0;
  packetsdone = 0;
  frameDone = 0;
  runPos = -1;
  //ΥȥХåե
  if((frameBuf = new char [READSIZE * fcp->frameUnit])==NULL)
    return -4;
  fcp->fseekTF(track, 0);
  totalFrame = fcp->trackLength[track];
  
  //̥ɥ饤Фν
  vorbis_info_init(&vi);
  if(vorbis_encode_init_vbr(&vi,ch , rate, quality)){
    vorbis_info_clear(&vi); 
    delete frameBuf;
    return -1;
  }
  //ӥåȥ졼Ȥ̤ʴϤʤ
  vorbis_encode_ctl(&vi, OV_ECTL_RATEMANAGE_SET, NULL);
  //󥳡ɤν
  vorbis_encode_setup_init(&vi);
  vorbis_analysis_init(&vd,&vi);
  vorbis_block_init(&vd,&vb);
  ogg_stream_init(&os, eserial);
  vorbis_comment_init(&vc);
  //إå
  vorbis_analysis_headerout(&vd,&vc,
			    &header_main,&header_comments,&header_codebooks);
  ogg_stream_packetin(&os,&header_main);
  ogg_stream_packetin(&os,&header_comments);
  ogg_stream_packetin(&os,&header_codebooks);
  
  //ե򳫤
  QCString foname = codec->fromUnicode(outName);
  if((fout=fopen((const char *)foname,"wb"))==NULL){
    retvalue = -2;
    goto cleanup;
  }
  status = 1;//ե򳫤ȥơѤ
  
  //إå񤭽Ф
  while(ogg_stream_flush(&os, &og) != 0){
    rcount = oe_write_page(&og, fout);
    if(rcount != og.header_len + og.body_len){
      retvalue = -3;
      goto cleanup;
    }
  }
  return 0;//ｪλ

 cleanup:
  /* Ԥѿκʬ */
  ogg_stream_clear(&os);
  vorbis_block_clear(&vb);
  vorbis_dsp_clear(&vd); 
  vorbis_info_clear(&vi);
  if(status==1)
    fclose(fout);
  delete frameBuf;
  status = 0;//ξ֤
  return retvalue;//ο֤
}

int VorbisDialog::runEncode(){
  int i,j,filech;
  unsigned char *v8;
  signed short *v16;
  long long rcount = 0;
  retvalue = 0;
  time_t sectmp;
  //߻ν
  if(status==3)
    goto cleanup;
  //̤μ¹
  while(!eos){
    //1äȤˡɽȴФ
    time(&sectmp);
    if(sectmp != secnow){
      secnow = sectmp;
      
      //if(runPos != frameDone*1000/totalFrame){
      //ץ쥹Сιʤɤ
      runPos = (int)((double)frameDone / (double)totalFrame * 1000.0);
      prog->setProgress(runPos);
      susumi->setText(QString::number(frameDone) + uni(" / ") +
		      QString::number(totalFrame) + uni(" ե졼 ") +
		      fcp->getHMS(secnow - secorg, 1) +
		      uni(" в"));
      //}
      
      // ޤ򥻥åȤƤä
      encTimer->start(1, TRUE);
      return 1;//ޤ³
    }
    
    // ȷѤfloatγǧ
    fsbuf = vorbis_analysis_buffer(&vd, READSIZE);

    // ȷǡɤ߹
    samples_read = fcp->freadF((void *)frameBuf, READSIZE, 1, mode);
    
    //FloatХåեͤ򥳥ԡ
    filech = fcp->sampleChannel;//ǡΥͥ
    switch(fcp->sampleBits){
    case 8:
      for(i=0;i<ch;i++){
	v8 = (unsigned char *)frameBuf;
	v8 += i;      //iͥƬΥץؤ
	for(j=0;j<samples_read;j++){
	  fsbuf[i][j] = (((int)(*v8)) - 128) / 128.0f;
	  v8 += filech;
	}
      }
      break;
    case 16:
      for(i=0;i<ch;i++){
	v16 = (signed short *)frameBuf;
	v16 += i; //iͥƬΥץؤ
	for(j=0;j<samples_read;j++){
	  fsbuf[i][j] = ((int)(*v16)) / 32768.0f; 
	  v16 += filech;
	}
      }
      break;
    }
    
    //̤ν
    frameDone += samples_read;//ɤ߼ä̤
    if(samples_read == 0){     //λȽ
      //ե졼ɤޤʤä
      vorbis_analysis_wrote(&vd,0);
    }else{
      //1ե졼ʾɤ
      //ɤ߹ץΤ餻
      vorbis_analysis_wrote(&vd, samples_read);
    }
    
    //񤭽ФƤ
    while(vorbis_analysis_blockout(&vd,&vb)==1){
      /* Do the main analysis, creating a packet */
      vorbis_analysis(&vb, NULL);
      vorbis_bitrate_addblock(&vb);
      while(vorbis_bitrate_flushpacket(&vd, &op)){
	ogg_stream_packetin(&os,&op);
	packetsdone++;
	while(!eos){
	  if(ogg_stream_pageout(&os,&og)==0)
	    break;
	  rcount = oe_write_page(&og, fout);
	  if(rcount != og.header_len + og.body_len){
	    retvalue = -3;
	    goto cleanup;
	  }
	  bytes_written += rcount;
	  if(ogg_page_eos(&og))
	    eos = 1;
	}
      }
    }
  }
  
 cleanup:
  //ץ쥹Сʤɤι
  runPos = (int)((double)frameDone / (double)totalFrame * 1000.0);
  prog->setProgress(runPos);
  //ʥ֥Ȥβ
  ogg_stream_clear(&os);
  vorbis_block_clear(&vb);
  vorbis_dsp_clear(&vd); 
  vorbis_info_clear(&vi);
  fclose(fout);
  delete frameBuf;
  //ɽλξ֤ˤ
  cancel->setDisabled(true);
  ok->setText(uni("Ĥ"));
  ok->setEnabled(true);
  time(&secnow);
  if(status==3)
    susumi->setText(uni("ߤޤ"));
  else if(eos && frameDone==totalFrame)
    susumi->setText(uni("˽λޤ в ") + 
		    fcp->getHMS(secnow-secorg, 1));
  else
    susumi->setText(uni("ߤޤ"));
  
  ok->setFocus();
  status = 2;//λξ֤Ȥʤ  
  return retvalue;//λ֤ͤ 
}

void VorbisDialog::closeEvent(QCloseEvent *e){
  if(status==1 || status==3){
    //ޤϰ̤ߺǤĤʤ
    e->ignore();
  }else{
    //Ĥ
    e->accept();
  }
}

void VorbisDialog::accept(){
  // debug  cout << "ץȤƤФ줿" << endl;
  //1ޤ3Ĥʤ
  if(status==1 || status==3)
    return;  
  
  QDialog::accept();
}
void VorbisDialog::reject(){
  // debug  cout << "ꥸȤƤФ줿" << endl;
  //1ޤ3Ĥʤ
  if(status==1 || status==3)
    return;
  
  QDialog::reject();
}
